
/* Chrysalide - Outil d'analyse de fichiers binaires
 * binop.h - prototypes pour les opérations booléennes impliquant deux opérandes
 *
 * Copyright (C) 2022 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_CONDS_BINOP_H
#define _ANALYSIS_SCAN_CONDS_BINOP_H


#include <glib-object.h>


#include "../cond.h"



#define G_TYPE_BINARY_OPERATION            g_binary_operation_get_type()
#define G_BINARY_OPERATION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_BINARY_OPERATION, GBinaryOperation))
#define G_IS_BINARY_OPERATION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_BINARY_OPERATION))
#define G_BINARY_OPERATION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_BINARY_OPERATION, GBinaryOperationClass))
#define G_IS_BINARY_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_BINARY_OPERATION))
#define G_BINARY_OPERATION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_BINARY_OPERATION, GBinaryOperationClass))


/* Opération booléenne impliquant deux opérandes (instance) */
typedef struct _GBinaryOperation GBinaryOperation;

/* Opération booléenne impliquant deux opérandes (classe) */
typedef struct _GBinaryOperationClass GBinaryOperationClass;


/* Types d'opérations booléennes disponibles */
typedef enum _BinOpType
{
    BOT_AND,
    BOT_OR,
    BOT_XOR,

} BinOpType;


/* Indique le type défini pour une opération booléenne de validation. */
GType g_binary_operation_get_type(void);

/* Met en place une représentation d'opération booléenne. */
GBinaryOperation *g_binary_operation_new(GMatchCondition *, GMatchCondition *, BinOpType);



#endif  /* _ANALYSIS_SCAN_CONDS_BINOP_H */
