
/* Chrysalide - Outil d'analyse de fichiers binaires
 * func.h - prototypes pour la définition d'une fonction ciblant une propriété pendant un scan
 *
 * Copyright (C) 2022 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_FUNC_H
#define _ANALYSIS_SCAN_FUNC_H


#include <glib-object.h>



#define G_TYPE_SCAN_FUNCTION            g_scan_function_get_type()
#define G_SCAN_FUNCTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_SCAN_FUNCTION, GScanFunction))
#define G_IS_SCAN_FUNCTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_SCAN_FUNCTION))
#define G_SCAN_FUNCTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_SCAN_FUNCTION, GScanFunctionClass))
#define G_IS_SCAN_FUNCTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_SCAN_FUNCTION))
#define G_SCAN_FUNCTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_SCAN_FUNCTION, GScanFunctionClass))


/* Fonction apportant un support d'analyse pendant un scan (instance) */
typedef struct _GScanFunction GScanFunction;

/* Fonction apportant un support d'analyse pendant un scan (classe) */
typedef struct _GScanFunctionClass GScanFunctionClass;


/* Indique le type défini pour une définition de fonction de scan. */
GType g_scan_function_get_type(void);



#endif  /* _ANALYSIS_SCAN_FUNC_H */
